//////////////////////////////////////////////////////////////////////////////////////
// 		Dfinition de petits codes assez utiles tout au long du jeu mais surtout  		//
// 		indispensables  sa beaut.																										//
//////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////

void attend(short temps)
{
	asm("	0:	move.w	#3000,%%d0
				1:	dbra		%%d0,1b
						dbra		%0,0b
			"::"d"(temps):"d0");
	
}

//////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////
//																																									//
//			Option 1: efface l'cran sur les deux plans.																//
//			Option 2: efface seulement le rectangle du menu sur les deux plans.					//
//																																									//
//////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////

void fade_down(short option)
{
	register short i;
	
	for(i = 0; i <= 8; i ++)
	{
	  attend(1);
	  OSContrastDn();
	}
	
	switch(option)
	{
		case 1:
		clr_plans();
		break;
		case 2:
		fill_rect(18, 26, 141, 81, 0, GRIS_CLAIR);
	  fill_rect(18, 26, 141, 81, 0, GRIS_FONCE);
	  break;
	}
	
	attend(5);
}

//////////////////////////////////////////////////////////////////////////////////////

void fade_up(void)
{
	register short i;
	
	for(i = 0; i <= 8; i ++)
	{
		attend(1);
		OSContrastUp();
	}
	
	get_key(2);
}

//////////////////////////////////////////////////////////////////////////////////////

void fond_ecran(void) // Fond d'cran pour les TI-92/92+/V200
{
	register short i, j;
	
	memset(plan0, 0, LCD_SIZE);
  memset(plan1, 0, LCD_SIZE);
  
	for(i = 0; i <= 239; i += 8)
	 {
		for(j = 0; j <= 127; j +=8)
		 {
			 Sprite8(i, j, 8, fond_0, plan0, SPRT_XOR);
			 Sprite8(i, j, 8, fond_1, plan1, SPRT_XOR);
		 }
	 }
}

//////////////////////////////////////////////////////////////////////////////////////

void enter_esc(void)
{
	do
	{
		get_key(1);
	}while(!ESCAPE && !ENTER);
	
}

//////////////////////////////////////////////////////////////////////////////////////

void disp_nivo(short nivo, short vie)
{
	char buffer[2*LCD_SIZE];
	
	sauve_pic(buffer);
	fill_rect(39, 27, 120, 67, 0,GRIS_CLAIR);
	fill_rect(39, 27, 120, 67, 0, GRIS_FONCE);
	draw_rect(40, 28, 119, 66, 4, GRIS_CLAIR);
	draw_rect(40, 28, 119, 66, 4, GRIS_FONCE);
	fill_rect(41, 29, 118, 65, 4, GRIS_FONCE);
	draw_num(47, 31, "Level:%02d", nivo, 2, GRIS_FONCE, GROS);
	draw_num(48, 32, "Level:%02d", nivo, 2, GRIS_CLAIR, GROS);
	draw_num(55, 46, vie > 1 ? "%02d Lives": "%02d Life", vie, 2, GRIS_FONCE, NORMAL);
	draw_num(56, 47, vie > 1 ? "%02d Lives": "%02d Life", vie, 2, GRIS_CLAIR, NORMAL);
	draw_str(53, 58, "Press [ENTER]...", 2, GRIS_FONCE, PETIT);
	
	do
	{
	  get_key(1);
	}while(!ENTER);
	
	restaure_pic(buffer);
}

//////////////////////////////////////////////////////////////////////////////////////

void disp_quit(short *vie)
{
	char buffer[2*LCD_SIZE];
	short y_quit;
	
	sauve_pic(buffer);
	fill_rect(4, 3, 155, 90, 2, GRIS_CLAIR);
	fill_rect(4, 3, 155, 90, 2, GRIS_FONCE);
	fill_rect(39, 27, 120, 67, 0, GRIS_CLAIR);
	fill_rect(39, 27, 120, 67, 0, GRIS_FONCE);
	draw_rect(40, 28, 119, 66, 4, GRIS_CLAIR);
	draw_rect(40, 28, 119, 66, 4, GRIS_FONCE);
	fill_rect(41, 29, 118, 41, 4, GRIS_FONCE);
	draw_str(55, 30, "ABORT?", 2, GRIS_FONCE, GROS);
	draw_str(56, 31, "ABORT?", 2, GRIS_CLAIR, GROS);
	fill_rect(41, 42, 118, 65, 4, GRIS_CLAIR);
	draw_str(67, 44, "Yes", 2, GRIS_CLAIR, GROS);
	draw_str(67, 44, "Yes", 4, GRIS_FONCE, GROS);
	draw_str(71, 55, "No", 2, GRIS_CLAIR, GROS);
	draw_str(71, 55, "No", 4, GRIS_FONCE, GROS);
	
	y_quit = 43;
	
	fill_rect(43, y_quit, 116, y_quit+10, 2, GRIS_FONCE);
	
	do
	{
		get_key(1);
		if(BAS || HAUT)
		{
			fill_rect(43, y_quit, 116, y_quit+10, 2, GRIS_FONCE);
			y_quit = y_quit == 43? 54: 43;
			fill_rect(43, y_quit, 116, y_quit+10, 2, GRIS_FONCE);
		}
	}while(!ENTER && !ESCAPE);
	
	restaure_pic(buffer);
	if(y_quit == 43 && ENTER)
	 *vie = 0;
}

//////////////////////////////////////////////////////////////////////////////////////

void disp_enter(void)
{
	fill_rect(1, 93, 158, 99, 0, GRIS_CLAIR);
	fill_rect(1, 93, 158, 99, 0, GRIS_FONCE);
	fill_rect(1, 93, 158, 99, 4, GRIS_CLAIR);
	draw_str(1, 94, "Press [ENTER]...", 4, GRIS_FONCE, PETIT);
	
	do
	{
	  get_key(1);
	}while(!ENTER);
	
}

//////////////////////////////////////////////////////////////////////////////////////

void disp_message(const char *string)
{
	fill_rect(5, 40, 154, 55, 0, GRIS_CLAIR);
	fill_rect(5, 40, 154, 55, 0, GRIS_FONCE);
	draw_rect(5, 40, 154, 55, 4, GRIS_FONCE);
	draw_rect(5, 40, 154, 55, 4, GRIS_CLAIR);
	fill_rect(7, 42, 152, 53, 4, GRIS_FONCE);
	draw_str((160-DrawStrWidth(string, 2))/2, 43, string, 2, GRIS_FONCE, GROS);
	draw_str((162-DrawStrWidth(string, 2))/2, 44, string, 2, GRIS_CLAIR, GROS);	
}

//////////////////////////////////////////////////////////////////////////////////////

void disp_crash(void)
{
	register short i;
	
	fill_rect(4, 3, 155 , 90, 2, GRIS_FONCE);
	disp_message("CRASH!");
	
	for(i = 1; i <= 6; i ++)
	{
		fill_rect(4, 3, 155, 90, 2, GRIS_FONCE);
		attend(12);	
	}	
	
	disp_enter();	
}

//////////////////////////////////////////////////////////////////////////////////////

void disp_bonus(short bonus)
{
	register short i, j;
	
	SetPlane(GRIS_FONCE);
	
	Choix_bonus:
	
	x_bonus = 4+8*random(19);
	y_bonus = 3+8*random(11);
	
	for(i = 0; i <= 7; i ++)
	{
		for(j = 0; j <= 7; j ++)
		{
			if(GetPix(ADAPT_x+x_bonus+i, ADAPT_y+y_bonus+j))
			 goto Choix_bonus;
		}
	}
	
	sprite8_GRIS(x_bonus, y_bonus, bonus_malus_0[bonus], bonus_malus_1[bonus]);
}

//////////////////////////////////////////////////////////////////////////////////////

void disp_pom(void)
{
	register short i;
	
	SetPlane(GRIS_FONCE);
	
	Choix_pom:
	
  x_pom = 4+4*random(38);
  y_pom = 3+4*random(22);
  
  for(i = 0; i <= 3; i ++)
  {
  	if(GetPix(ADAPT_x+x_pom+i, ADAPT_y+y_pom+i))
  	 goto Choix_pom;
  }
  
	sprite8_GRIS(x_pom, y_pom, pom_0, pom_1);
}

//==========================================================================//

static inline void OuvreFichierSauvegarde(void)
{
	char extension[] = "SAV";
	char signature[] = "PYTHV1";
	
	entry = DerefSym(SymFindMain(SYMSTR("pythsav")));
	
	if (entry != NULL)
	{
		Hsc = (unsigned char *)HLock(entry->handle);
		if (memcmp(Hsc+2, signature, 6) != 0)
		{
			HeapUnlock(entry->handle);
			goto Nouveau;
		}
		vitesse = *(Hsc+8);
		ordre = *(Hsc+9);
		memcpy(high, Hsc+10, 75);
	}
	else
	{
	  Nouveau:
		entry = DerefSym(SymAddMain(SYMSTR("pythsav")));
		Hsc = (unsigned char *)HLock(entry->handle = HeapAlloc(91));
		*(unsigned short *)Hsc = 89;
		strcpy(Hsc+2, signature);
		*(Hsc+85) = 0;
		strcpy(Hsc+86, extension);
		*(Hsc+89) = 0;
		*(Hsc+90) = OTH_TAG;
	}
}

//==========================================================================//

static inline void FermeFichierSauvegarde(void)
{
	*(Hsc+8) = vitesse;
	*(Hsc+9) = ordre;
	memcpy(Hsc+10, high, 75);
	HeapUnlock(entry->handle);
}

//==========================================================================//